"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.createInstance = void 0;

var _react = _interopRequireDefault(require("react"));

var _helpers = require("./helpers.js");

var _propTypes = _interopRequireDefault(require("./propTypes.js"));

var _reducer2 = require("./reducer.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * createInstance allows you to create instances of Async that are bound to a specific promise.
 * A unique instance also uses its own React context for better nesting capability.
 */
var createInstance = function createInstance() {
  var defaultProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var displayName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Async";

  var _React$createContext = _react["default"].createContext(),
      Consumer = _React$createContext.Consumer,
      Provider = _React$createContext.Provider;

  var Async =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(Async, _React$Component);

    function Async(props) {
      var _this;

      _classCallCheck(this, Async);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Async).call(this, props));
      _this.start = _this.start.bind(_assertThisInitialized(_this));
      _this.load = _this.load.bind(_assertThisInitialized(_this));
      _this.run = _this.run.bind(_assertThisInitialized(_this));
      _this.cancel = _this.cancel.bind(_assertThisInitialized(_this));
      _this.onResolve = _this.onResolve.bind(_assertThisInitialized(_this));
      _this.onReject = _this.onReject.bind(_assertThisInitialized(_this));
      _this.setData = _this.setData.bind(_assertThisInitialized(_this));
      _this.setError = _this.setError.bind(_assertThisInitialized(_this));
      var promise = props.promise;
      var promiseFn = props.promiseFn || defaultProps.promiseFn;
      var initialValue = props.initialValue || defaultProps.initialValue;
      _this.mounted = false;
      _this.counter = 0;
      _this.args = [];
      _this.abortController = {
        abort: function abort() {}
      };
      _this.state = _objectSpread({}, (0, _reducer2.init)({
        initialValue: initialValue,
        promise: promise,
        promiseFn: promiseFn
      }), {
        cancel: _this.cancel,
        run: _this.run,
        reload: function reload() {
          var _this2;

          _this.load();

          (_this2 = _this).run.apply(_this2, _toConsumableArray(_this.args));
        },
        setData: _this.setData,
        setError: _this.setError
      });
      _this.debugLabel = props.debugLabel || defaultProps.debugLabel;

      var _ref = window.__REACT_ASYNC__ || {},
          devToolsDispatcher = _ref.devToolsDispatcher;

      var _reducer = props.reducer || defaultProps.reducer;

      var _dispatcher = props.dispatcher || defaultProps.dispatcher || devToolsDispatcher;

      var reducer = _reducer ? function (state, action) {
        return _reducer(state, action, _reducer2.reducer);
      } : _reducer2.reducer;
      var dispatch = (0, _reducer2.dispatchMiddleware)(function (action, callback) {
        _this.setState(function (state) {
          return reducer(state, action);
        }, callback);
      });
      _this.dispatch = _dispatcher ? function (action) {
        return _dispatcher(action, dispatch, props);
      } : dispatch;
      return _this;
    }

    _createClass(Async, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.mounted = true;

        if (this.props.promise || !this.state.initialValue) {
          this.load();
        }
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        var _this$props = this.props,
            watch = _this$props.watch,
            _this$props$watchFn = _this$props.watchFn,
            watchFn = _this$props$watchFn === void 0 ? defaultProps.watchFn : _this$props$watchFn,
            promise = _this$props.promise,
            promiseFn = _this$props.promiseFn;
        if (watch !== prevProps.watch) this.load();
        if (watchFn && watchFn(_objectSpread({}, defaultProps, this.props), _objectSpread({}, defaultProps, prevProps))) this.load();

        if (promise !== prevProps.promise) {
          if (promise) this.load();else this.cancel();
        }

        if (promiseFn !== prevProps.promiseFn) {
          if (promiseFn) this.load();else this.cancel();
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.cancel();
        this.mounted = false;
      }
    }, {
      key: "getMeta",
      value: function getMeta(meta) {
        return _objectSpread({
          counter: this.counter,
          debugLabel: this.debugLabel
        }, meta);
      }
    }, {
      key: "start",
      value: function start(promiseFn) {
        var _this3 = this;

        if ("AbortController" in window) {
          this.abortController.abort();
          this.abortController = new window.AbortController();
        }

        this.counter++;
        return new Promise(function (resolve, reject) {
          if (!_this3.mounted) return;

          var executor = function executor() {
            return promiseFn().then(resolve, reject);
          };

          _this3.dispatch({
            type: _reducer2.actionTypes.start,
            payload: executor,
            meta: _this3.getMeta()
          });
        });
      }
    }, {
      key: "load",
      value: function load() {
        var _this4 = this;

        var promise = this.props.promise;

        if (promise) {
          return this.start(function () {
            return promise;
          }).then(this.onResolve(this.counter), this.onReject(this.counter));
        }

        var promiseFn = this.props.promiseFn || defaultProps.promiseFn;

        if (promiseFn) {
          var props = _objectSpread({}, defaultProps, this.props);

          return this.start(function () {
            return promiseFn(props, _this4.abortController);
          }).then(this.onResolve(this.counter), this.onReject(this.counter));
        }
      }
    }, {
      key: "run",
      value: function run() {
        var _this5 = this;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var deferFn = this.props.deferFn || defaultProps.deferFn;

        if (deferFn) {
          this.args = args;

          var props = _objectSpread({}, defaultProps, this.props);

          return this.start(function () {
            return deferFn(args, props, _this5.abortController);
          }).then(this.onResolve(this.counter), this.onReject(this.counter));
        }
      }
    }, {
      key: "cancel",
      value: function cancel() {
        this.counter++;
        this.abortController.abort();
        this.mounted && this.dispatch({
          type: _reducer2.actionTypes.cancel,
          meta: this.getMeta()
        });
      }
    }, {
      key: "onResolve",
      value: function onResolve(counter) {
        var _this6 = this;

        return function (data) {
          if (_this6.counter === counter) {
            var onResolve = _this6.props.onResolve || defaultProps.onResolve;

            _this6.setData(data, function () {
              return onResolve && onResolve(data);
            });
          }

          return data;
        };
      }
    }, {
      key: "onReject",
      value: function onReject(counter) {
        var _this7 = this;

        return function (error) {
          if (_this7.counter === counter) {
            var onReject = _this7.props.onReject || defaultProps.onReject;

            _this7.setError(error, function () {
              return onReject && onReject(error);
            });
          }

          return error;
        };
      }
    }, {
      key: "setData",
      value: function setData(data, callback) {
        this.mounted && this.dispatch({
          type: _reducer2.actionTypes.fulfill,
          payload: data,
          meta: this.getMeta()
        }, callback);
        return data;
      }
    }, {
      key: "setError",
      value: function setError(error, callback) {
        this.mounted && this.dispatch({
          type: _reducer2.actionTypes.reject,
          payload: error,
          error: true,
          meta: this.getMeta()
        }, callback);
        return error;
      }
    }, {
      key: "render",
      value: function render() {
        var children = this.props.children;

        if (typeof children === "function") {
          return _react["default"].createElement(Provider, {
            value: this.state
          }, children(this.state));
        }

        if (children !== undefined && children !== null) {
          return _react["default"].createElement(Provider, {
            value: this.state
          }, children);
        }

        return null;
      }
    }]);

    return Async;
  }(_react["default"].Component);

  if (_propTypes["default"]) Async.propTypes = _propTypes["default"].Async;

  var AsyncInitial = function AsyncInitial(props) {
    return _react["default"].createElement(Consumer, null, function (st) {
      return _react["default"].createElement(_helpers.Initial, _extends({}, props, {
        state: st
      }));
    });
  };

  var AsyncPending = function AsyncPending(props) {
    return _react["default"].createElement(Consumer, null, function (st) {
      return _react["default"].createElement(_helpers.Pending, _extends({}, props, {
        state: st
      }));
    });
  };

  var AsyncFulfilled = function AsyncFulfilled(props) {
    return _react["default"].createElement(Consumer, null, function (st) {
      return _react["default"].createElement(_helpers.Fulfilled, _extends({}, props, {
        state: st
      }));
    });
  };

  var AsyncRejected = function AsyncRejected(props) {
    return _react["default"].createElement(Consumer, null, function (st) {
      return _react["default"].createElement(_helpers.Rejected, _extends({}, props, {
        state: st
      }));
    });
  };

  var AsyncSettled = function AsyncSettled(props) {
    return _react["default"].createElement(Consumer, null, function (st) {
      return _react["default"].createElement(_helpers.Settled, _extends({}, props, {
        state: st
      }));
    });
  };

  AsyncInitial.displayName = "".concat(displayName, ".Initial");
  AsyncPending.displayName = "".concat(displayName, ".Pending");
  AsyncFulfilled.displayName = "".concat(displayName, ".Fulfilled");
  AsyncRejected.displayName = "".concat(displayName, ".Rejected");
  AsyncSettled.displayName = "".concat(displayName, ".Settled");
  Async.displayName = displayName;
  Async.Initial = AsyncInitial;
  Async.Pending = AsyncPending;
  Async.Loading = AsyncPending; // alias

  Async.Fulfilled = AsyncFulfilled;
  Async.Resolved = AsyncFulfilled; // alias

  Async.Rejected = AsyncRejected;
  Async.Settled = AsyncSettled;
  return Async;
};

exports.createInstance = createInstance;

var _default = createInstance();

exports["default"] = _default;